Package com.documentum.fc.client.search

# Interface IDfSearchTypeAssistant

public interface IDfSearchTypeAssistant
Provides a facade to search metadata for a given value. Uses lazy initialization.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getAttrDataType(String attrName)`
  Retrieves the datatype of an attribute.
  `String`
  `getAttributeLabel(String attrName)`
  Retrieves a localized attribute label for a given attribute.
  `IDfEnumeration`
  `getAttributeNames()`
  Retrieves an enumeration of the names of the searchable attributes for the type.
  `String`
  `getDefaultAttribute()`
  Provides access to a default attribute for the type.
  `String`
  `getDefaultSearchOp(String attrName)`
  Retrieves the default search operation as a string code (such as "10", "1", ...) for an attribute.
  `String`
  `getDefaultValue(String attrName)`
  Retrieves the default search value for the specified attribute.
  `String`
  `getDefaultValue(String attrName, String searchOp)`
  Deprecated.
  `String`
  `getSearchOpLabel(String attrName, String searchOp)`
  Retrieves a localized search operation label (such as "Greater than", "Equal", ...) for a given search operation code.
  `IDfEnumeration`
  `getSearchOpLabels(String attrName)`
  Retrieves an enumeration of the localized search operation labels (such as "Greater than", "Equal", ...).
  `IDfEnumeration`
  `getSearchOps(String attrName)`
  Retrieves an enumeration of search operations as string codes (such as "10", "1", ...).
  `String`
  `getSuperName()`
  Gets the super-type name.
  `IDfType`
  `getType()`
  Returns a read only copy of IDfType object disconnected from the current session.
  `String`
  `getTypeLabel()`
  Gets the type label.
  `String`
  `getTypeName()`
  Gets the type name.
  `IDfValueAssistance`
  `getValueAssistance(IDfExpression rootExpr, IDfAttrExpression vaExpr)`
  Gets the value assistance of an attribute with dependencies to other attributes values.
  `IDfValueAssistance`
  `getValueAssistance(String attrName)`
  Gets the value assistance of an attribute without dependencies to other attributes values.
  `String`
  `getValueLabel(String attrName, String searchOp, String value)`
  Deprecated.
  `IDfEnumeration`
  `getValues(String attrName, String searchOp)`
  Deprecated.
  `boolean`
  `hasAttribute(String attribute)`
  Checks if an attribute is available on the type.
  An attribute name may be available on a type, even if it does not appear in the enumeration of `getAttributeNames()`: Aspect attributes: they are not part of the type, but they may be supported by the type (and in queries) Non searchable attributes: `getAttributeNames()` returns only the searchable attributes.
  `boolean`
  `hasValueAssistance(String attrName)`
  Indicates whether a value assistance is available for an attribute.
  `boolean`
  `hasValueAssistanceDependencies(String attrName)`
  Indicates whether the value assistance of an attribute defines dependencies on other attributes values.
  `boolean`
  `isAttributeRepeated(String attrName)`
  Tests if a given attribute is repeated.
  `boolean`
  `isFulltextCompliant()`
  Returns a boolean value indicating whether the type assistant is in a full-text compliant mode.
  `void`
  `setFulltextCompliant(boolean fulltextCompliant)`
  Switches the mode for supporting only full-text compliant constructs.

- ## Method Details

  - ### getTypeName

    String getTypeName()
    Gets the type name.
    Returns:
      The type name.

  - ### getTypeLabel

    String getTypeLabel() throws DfException
    Gets the type label.
    Returns:
      The type label.
    Throws:
      `DfException` - If an error occurs while getting the label.

  - ### getType

    IDfType getType() throws DfException
    Returns a read only copy of IDfType object disconnected from the current session.
    Returns:
      The type.
    Throws:
      `DfException` - If an error occurs while getting the type.

  - ### getSuperName

    String getSuperName() throws DfException
    Gets the super-type name.
    Returns:
      The super-type name.
    Throws:
      `DfException` - If an error occurs while getting the super-type.

  - ### isFulltextCompliant

    boolean isFulltextCompliant()
    Returns a boolean value indicating whether the type assistant is in a full-text compliant mode. If compliance is requested, some of the metadata options that can break the compliance are excluded from the returned containers.
    Returns:
      `true`, if full-text compliance is requested; `false`, otherwise.

  - ### setFulltextCompliant

    void setFulltextCompliant(boolean fulltextCompliant)
    Switches the mode for supporting only full-text compliant constructs.
    Parameters:
      `fulltextCompliant` - `true`, if full-text compliance is requested; `false`, otherwise.

  - ### getDefaultAttribute

    String getDefaultAttribute() throws DfException
    Provides access to a default attribute for the type. Typically, it is object_name.
    Returns:
      The name of the default attribute.
    Throws:
      `DfException` - If an error occurs while getting the default attribute.

  - ### getAttributeNames

    IDfEnumeration getAttributeNames() throws DfException
    Retrieves an enumeration of the names of the searchable attributes for the type.
    Returns:
      An enumeration of attribute names (IDfEnumeration of String objects).
    Throws:
      `DfException` - If an error occurs while getting the attributes.

  - ### hasAttribute

    boolean hasAttribute(String attribute) throws DfException
    Checks if an attribute is available on the type.
    An attribute name may be available on a type, even if it does not appear in the enumeration of `getAttributeNames()`:
    - Aspect attributes: they are not part of the type, but they may be supported by the type (and in queries)
    - Non searchable attributes: `getAttributeNames()` returns only the searchable attributes. However non searchable attributes can still be retrieved (in results attributes for example).
    Parameters:
      `attribute` - The attribute name.
    Returns:
      `true`, if the attribute is available; `false`, otherwise.
    Throws:
      `DfException` - If an error occurs while getting the attributes.

  - ### getAttributeLabel

    String getAttributeLabel(String attrName) throws DfException
    Retrieves a localized attribute label for a given attribute.
    Parameters:
      `attrName` - The name of the attribute.
    Returns:
      The localized attribute label.
    Throws:
      `DfException` - If an error occurs while getting the attribute label.

  - ### isAttributeRepeated

    boolean isAttributeRepeated(String attrName) throws DfException
    Tests if a given attribute is repeated.
    Parameters:
      `attrName` - The name of the attribute.
    Returns:
      `true`, if the attribute is repeated; `false`, otherwise.
    Throws:
      `DfException` - If an error occurs while getting the attribute info.

  - ### getAttrDataType

    int getAttrDataType(String attrName) throws DfException
    Retrieves the datatype of an attribute.
    The following list specifies the dataype corresponding to all return values. The possible return values are:
    - `IDfValue.DF_BOOLEAN`
    - `IDfValue.DF_INTEGER`
    - `IDfValue.DF_STRING`
    - `IDfValue.DF_ID`
    - `IDfValue.DF_TIME`
    - `IDfValue.DF_DOUBLE`
    Parameters:
      `attrName` - The name of the attribute.
    Returns:
      An integer representing the datatype of the attribute.
    Throws:
      `DfException` - If an error occurs while getting the attribute info.

  - ### getDefaultSearchOp

    String getDefaultSearchOp(String attrName) throws DfException
    Retrieves the default search operation as a string code (such as "10", "1", ...) for an attribute.
    Parameters:
      `attrName` - The name of the inquired attribute.
    Returns:
      A string representing the search operation code.
    Throws:
      `DfException` - If an error occurs while getting the default search operation.

  - ### getSearchOps

    IDfEnumeration getSearchOps(String attrName) throws DfException
    Retrieves an enumeration of search operations as string codes (such as "10", "1", ...).
    Parameters:
      `attrName` - The name of the inquired attribute.
    Returns:
      An enumeration of string representing the search operation code (IDfEnumeration of String).
    Throws:
      `DfException` - If an error occurs while getting the search operations.

  - ### getSearchOpLabels

    IDfEnumeration getSearchOpLabels(String attrName) throws DfException
    Retrieves an enumeration of the localized search operation labels (such as "Greater than", "Equal", ...).
    Parameters:
      `attrName` - The name of the attribute.
    Returns:
      An enumeration of strings representing the localized search operation labels (IDfEnumeration of String).
    Throws:
      `DfException` - If an error occurs while getting the search operations labels.

  - ### getSearchOpLabel

    String getSearchOpLabel(String attrName, String searchOp) throws DfException
    Retrieves a localized search operation label (such as "Greater than", "Equal", ...) for a given search operation code.
    Parameters:
      `attrName` - The name of the attribute.
      `searchOp` - The search operation.
    Returns:
      The localized search operation label.
    Throws:
      `DfException` - If an error occurs while getting the search operation label.

  - ### getDefaultValue

    String getDefaultValue(String attrName) throws DfException
    Retrieves the default search value for the specified attribute. Notice that the value is the actual value that will be used in the search, not the display label of the search. For example: 10.
    Parameters:
      `attrName` - The name of the attribute.
    Returns:
      The default search value.
    Throws:
      `DfException` - If an error occurs while getting the default search value.

  - ### getDefaultValue

    String getDefaultValue(String attrName, String searchOp) throws DfException
    Deprecated.
    See `getDefaultValue(String)`
    Throws:
      `DfException`

  - ### hasValueAssistance

    boolean hasValueAssistance(String attrName) throws DfException
    Indicates whether a value assistance is available for an attribute.
    Parameters:
      `attrName` - The name of the attribute.
    Returns:
      `true`, if a value assistance is available; `false`, otherwise.
    Throws:
      `DfException` - If an error occurs while accessing the value assistance item.

  - ### hasValueAssistanceDependencies

    boolean hasValueAssistanceDependencies(String attrName) throws DfException
    Indicates whether the value assistance of an attribute defines dependencies on other attributes values.
    Parameters:
      `attrName` - The name of the attribute.
    Returns:
      `true`, if a value assistance item defines dependencies to other attributes values; `false`, otherwise.
    Throws:
      `DfException` - If an error occurs while accessing the value assistance setting.

  - ### getValueAssistance

    IDfValueAssistance getValueAssistance(String attrName) throws DfException
    Gets the value assistance of an attribute without dependencies to other attributes values.
    Parameters:
      `attrName` - The name of the attribute.
    Returns:
      The value assistance for the attribute.
    Throws:
      `DfException` - If an error occurs while accessing the value assistance item.

  - ### getValueAssistance

    IDfValueAssistance getValueAssistance(IDfExpression rootExpr, IDfAttrExpression vaExpr) throws DfException
    Gets the value assistance of an attribute with dependencies to other attributes values. This method requires a first parameter that defines the entire search expression tree in which all attributes are defined with their values. The second parameter is the specific search expression (within the expression tree) to find out the value assistance for.
    Parameters:
      `rootExpr` - The root of the search expression tree.
      `vaExpr` - The specific search expression (within the expression tree) for which you want to find value assistance.
    Returns:
      The value assistance for the attribute of the specific search expression.
    Throws:
      `DfException` - If an error occurs while accessing the value assistance item.

  - ### getValues

    IDfEnumeration getValues(String attrName, String searchOp) throws DfException
    Deprecated.
    See `getValueAssistance(String)`
    Throws:
      `DfException`

  - ### getValueLabel

    String getValueLabel(String attrName, String searchOp, String value) throws DfException
    Deprecated.
    See `getValueAssistance(String)`
    Throws:
      `DfException`